# GUI для FreeRDP

- Основано на базе [FreeRDP 2.10.0](https://github.com/FreeRDP/FreeRDP) ([локальная версия](http://git.belpig.ru/forks/FreeRDP))
- Надстройка для FreeRDP на основе библиотеки [`IUP`](https://www.tecgraf.puc-rio.br/iup/).

![main.png](img/main.png)
![settings.png](img/settings.png)

## Сборка программы

- [xrandr.patch](xrandr.patch) - исправления поиска библиотеки `Xrandr`
- [gui.patch](gui.patch) - включение использования GUI в оригинальный проект `freerdp`

### Подготовка

Скопировать файлы из [freerdp](freerdp/) в оригинальный проект `(2.10.0)`:

```sh
cp -r GUI-FreeRDP/freerdp/* freerdp-2.10.0/
```

Перейти в оригинальный каталог:

```sh
cd freerdp-2.10.0
```

Применить патчи:

```sh
git apply ../GUI-FreeRDP/gui.patch
git apply ../GUI-FreeRDP/xrandr.patch
```

## Сборка

Параметры сборки:

- `IUP_WITH_COLOR_BUTTONS` - поддержка цветных кнопок (по умолчанию `OFF`)
- `IUP_WITH_SOUND_CHECKBOX` - поддержка параметров звука (по умолчанию `OFF`)
- `IUP_DESCRIPTION_ABOUT_ARCH_X32` - в описании "О прогамме" отобразить пометку для x32 архитектур (по умолчанию `OFF`)
- `IUP_WITH_LANGUAGE_KEYBOARD_ICON` - поддержка отображения раскладки клавиатуры (по умолчанию `OFF`)
- `IUP_DESCRIPTION_ABOUT_MIRATORG` - в описании "О прогамме" отобразить рабочие контактные данные (по умолчанию `OFF`)

Создать отдельный каталог `build`:

```sh
mkdir build
cd build
```

и выполнить в нём сборку:

```sh
cmake -B . -S ../freerdp-2.10.0 \
    -DWITH_WAYLAND=OFF \
    -DWITH_OSS=OFF \
    -DWITH_ALSA=OFF \
    -DWITH_PULSE=OFF \
    -DWITH_CUPS=OFF \
    -DWITH_PCSC=OFF \
    -DWITH_FFMPEG=OFF \
    -DWITH_OPENSSL=ON \
    -DWITH_XV=OFF \
    -DWITH_FUSE=OFF \
    -DWITH_SWSCALE=OFF \
    -DWITH_CAIRO=OFF \
    -DWITH_DSP_FFMPEG=OFF \
    -DWITH_FAAC=OFF \
    -DWITH_SSE2=ON \
    -DBUILD_SHARED_LIBS=OFF \
    -DIUP_WITH_COLOR_BUTTONS=ON \
    -DIUP_WITH_SOUND_CHECKBOX=OFF \
    -DIUP_DESCRIPTION_ABOUT_ARCH_X32=OFF \
    -DIUP_WITH_LANGUAGE_KEYBOARD_ICON=ON \
    -DIUP_DESCRIPTION_ABOUT_MIRATORG=ON
```

и компиляцию программы:

```sh
make -j16
```
